/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.scene.sPos.Position
 */
package fire.script;

import fire.pb.scene.sPos.Position;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

public class SearchIsland {
    public static void main(String[] args) {
        byte[][] blockinfo = new byte[20][30];
        for (int i = 0; i < blockinfo.length; ++i) {
            for (int j = 0; j < blockinfo[i].length; ++j) {
                blockinfo[i][j] = Math.random() < 0.5 ? 0 : -1;
            }
        }
        SearchIsland.printArray(blockinfo);
        SearchIsland.processBlockInfo(blockinfo);
        SearchIsland.printArray(blockinfo);
    }

    public static void processBlockInfo(byte[][] blockinfo) {
        byte islandindex = 1;
        for (int x = 0; x < blockinfo.length; ++x) {
            for (int y = 0; y < blockinfo[x].length; ++y) {
                if (blockinfo[x][y] != 0) continue;
                blockinfo[x][y] = islandindex;
                List<Position> poses = new LinkedList<Position>();
                poses.add(new Position(x, y));
                while (!poses.isEmpty()) {
                    poses = SearchIsland.processAdjacentPoses(blockinfo, poses, islandindex);
                }
                islandindex = (byte)(islandindex + 1);
            }
        }
        System.out.println("本地图一共有 " + (islandindex - 1) + " 个孤岛");
    }

    public static void processIsland(byte[][] blockinfo, int x, int y, byte islandindex) {
        int maxx = blockinfo.length;
        int maxy = blockinfo[x].length;
        for (Position pos : SearchIsland.getAdjacentPos(x, y, maxx, maxy)) {
            int tmpy;
            int tmpx = pos.getX();
            if (blockinfo[tmpx][tmpy = pos.getY()] != 0 || !SearchIsland.validPos(blockinfo, x, y, tmpx, tmpy)) continue;
            blockinfo[tmpx][tmpy] = islandindex;
            SearchIsland.processIsland(blockinfo, tmpx, tmpy, islandindex);
        }
    }

    public static boolean validPos(byte[][] blockinfo, int x, int y, int tmpx, int tmpy) {
        if (x == tmpx || y == tmpy) {
            return true;
        }
        if (blockinfo[x][tmpy] == -1 && blockinfo[tmpx][y] == -1) {
            System.out.println("坐标(" + x + "," + y + ")与坐标(" + tmpx + "," + tmpy + ")位置不合法");
            return false;
        }
        return true;
    }

    public static List<Position> getAdjacentPos(int x, int y, int maxx, int maxy) {
        ArrayList<Position> ret = new ArrayList<Position>();
        for (int i = x - 1; i <= x + 1; ++i) {
            for (int j = y - 1; j <= y + 1; ++j) {
                if (i < 0 || i >= maxx || j < 0 || j >= maxy || i == x && j == y) continue;
                ret.add(new Position(i, j));
            }
        }
        return ret;
    }

    public static List<Position> processAdjacentPoses(byte[][] blockinfo, List<Position> poses, byte islandindex) {
        int maxx = blockinfo.length;
        int maxy = blockinfo[0].length;
        ArrayList<Position> adjposes = new ArrayList<Position>();
        for (Position pos : poses) {
            for (Position adjpos : SearchIsland.getAdjacentPos(pos.getX(), pos.getY(), maxx, maxy)) {
                int tmpy;
                int tmpx = adjpos.getX();
                if (blockinfo[tmpx][tmpy = adjpos.getY()] != 0 || !SearchIsland.validPos(blockinfo, pos.getX(), pos.getY(), tmpx, tmpy)) continue;
                blockinfo[tmpx][tmpy] = islandindex;
                adjposes.add(adjpos);
            }
        }
        return adjposes;
    }

    public static void printArray(byte[][] array) {
        for (int j = 0; j < array[0].length; ++j) {
            String str = "";
            for (int i = 0; i < array.length; ++i) {
                str = array[i][j] >= 0 && array[i][j] < 10 ? str + " " + array[i][j] + " " : str + array[i][j] + " ";
            }
            System.out.println(str);
        }
    }
}

